
#pragma newdecls required
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <tf2>
#include <tf2_stocks>

public Plugin myinfo = 
{

	name = "cp_orange_z7_n Map glitch fixed",
	author = "w1200441",
	description = "No more guns in blue melee area, no more teleport build in red spawn!",
	version = "1.0.0",
	url = "https://steamcommunity.com/id/w1200441/"
};

public void OnPluginStart()
{
	RegAdminCmd("sm_w12rebuild", Command_ReBuild, ADMFLAG_CHEATS, "Rebuild Emtites");	
	HookEvent("teamplay_round_active", Event_RoundActive, EventHookMode_Pre);
}
public void OnMapStart()
{
	CreateTimer(2.0, HookMapEntrty);
}
public void Event_RoundActive(Event event, const char[] name, bool dontBroadcast)
{
	char map[32]; GetCurrentMap(map, sizeof(map));
	if(StrEqual(map, "cp_orange_z7_n"))
	{
		ServerCommand("sm_w12rebuild");
	}
}
public Action Command_ReBuild(int client, int args)
{
	char map[32]; GetCurrentMap(map, sizeof(map));
	if(StrEqual(map, "cp_orange_z7_n"))
	{
		CreateTimer(0.0, RemoveAll);
		CreateTimer(1.0, BuildMap);
		CreateTimer(2.0, HookMapEntrty);
	}
	else ReplyToCommand(client, "Command enable for map [ cp_orange_z7_n ] only.");
	
	return Plugin_Handled;
}
Action RemoveAll(Handle timer)
{
	char map[32]; GetCurrentMap(map, sizeof(map));
	if(StrEqual(map, "cp_orange_z7_n"))
	{
		int iEntity;
		iEntity = -1;
		while ((iEntity = FindEntityByClassname(iEntity, "func_nobuild")) != -1)
		{
			char name[128]; GetEntPropString(iEntity, Prop_Data, "m_iName", name, sizeof(name));
			if(StrEqual(name, "MapEntity"))
			{
				AcceptEntityInput(iEntity, "Kill");
			}
		}
	}
	return Plugin_Stop;
}
Action BuildMap(Handle timer)
{
	char map[32]; GetCurrentMap(map, sizeof(map));
	if(StrEqual(map, "cp_orange_z7_n"))
	{
		int prop;
		prop = CreateEntityByName("func_nobuild");
		if (IsValidEntity(prop))
		{
			DispatchKeyValue(prop, "targetname", "EntityMap");
			DispatchKeyValue(prop, "model", "*99");
			DispatchKeyValue(prop, "origin", "350 4867 -1650");
			DispatchKeyValue(prop, "angles", "45 90 0");
			DispatchKeyValue(prop, "DestroyBuildings", "1");
			DispatchSpawn(prop);
			ActivateEntity(prop);
		}
	}
	return Plugin_Stop;
}
Action HookMapEntrty(Handle timer)
{
	char map[32]; GetCurrentMap(map, sizeof(map));
	if(StrEqual(map, "cp_orange_z7_n"))
	{
		int entities;
		entities = -1;
		while ((entities = FindEntityByClassname(entities, "trigger_add_tf_player_condition")) != -1)
		{
			char modelname[128]; GetEntPropString(entities, Prop_Data, "m_ModelName", modelname, sizeof(modelname));
			if (StrEqual(modelname, "*202")||StrEqual(modelname, "*238"))
			{
				HookSingleEntityOutput(entities, "OnStartTouch", OnAreaMeleeCondition);
				HookSingleEntityOutput(entities, "OnEndTouch", OnAreaMeleeCondition);
			}
		}
		while ((entities = FindEntityByClassname(entities, "trigger_teleport")) != -1)
		{
			char modelname[128]; GetEntPropString(entities, Prop_Data, "m_ModelName", modelname, sizeof(modelname));
			if(StrEqual(modelname, "*154")||StrEqual(modelname, "*166"))
			{
				HookSingleEntityOutput(entities, "OnEndTouch", OnTeleportToSpawnRoom);
			}
		}
	}
	return Plugin_Stop;
}
public void OnAreaMeleeCondition(const char[] output, int caller, int activator, float delay)
{
	if(IsValidClient(activator) && IsValidEntity(caller))
	{
		if(!TF2_IsPlayerInCondition(activator, TFCond_RestrictToMelee)) TF2_AddCondition(activator, TFCond_RestrictToMelee, TFCondDuration_Infinite);
		SetEntPropEnt(activator, Prop_Send, "m_hActiveWeapon", GetPlayerWeaponSlot(activator, TFWeaponSlot_Melee));
	}
}
public void OnTeleportToSpawnRoom(const char[] output, int caller, int activator, float delay)
{
	if(IsValidClient(activator) && IsValidEntity(caller))
	{
		if(TF2_IsPlayerInCondition(activator, TFCond_RestrictToMelee)) TF2_RemoveCondition(activator, TFCond_RestrictToMelee);
		TF2_RegeneratePlayer(activator);
	}
}
//===============================================================================================================================================================================================================================================
bool IsValidClient(int client) 
{
    if (client <= 0) return false;
    if (client > MaxClients) return false;
    return IsClientInGame(client);
}